#!/usr/bin/perl
##############################################################################
=pod

=head1 NAME

dirWatchers

=head1 DESCRPTION

extracts the interesteing links from a given HTML file and
recusrively parses the files that are pointed inside if they match something
inside the patternServer.


=head1 AUTHOR

  Bruno Bttcher <bboett at adlp dot org>

=head1 COPYRIGHT and LICENCE

 Copyright (c) 2002 Bruno Boettcher

 patternQuery.pl is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; version 2
 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


=cut

##############################################################################
use warnings;
use strict;
sub BEGIN
{
    push (@INC,$ENV{HOME}.'/download/leverloda/goanseech')
        if(!( (join(' ',@INC)) =~ /$ENV{HOME}\/\.leve\/lib/));
}

use Data::Dumper;
use POE::Component::goanseech::fileWatcher;
use POE::Component::goanseech::seriesConnector;

#sub POE::Kernel::ASSERT_EVENTS () { 1 }
#sub POE::Kernel::ASSERT_STATES () { 1 }
use POE;

my $rootpath = $ENV{HOME}."/.goanseech/";


while(scalar(@ARGV) >0)
{
  my $key = shift(@ARGV);
  if($key =~ /--config/i)
  {
    $rootpath = shift(@ARGV);
  }# if($key =~ /--config/i)
  else
  {
    die("Invalid switch: valid is --config\n");
  }# else
}# if(scalar(@ARGV) >0)
$rootpath .= "/" if(!($rootpath =~ /\/$/));

my $settings = do($rootpath."settings.pm");

#one shot call, if you want to change this, remove the line below
  $settings->{"dirscan"} = 0;
my $dirSession = "dirFetcher";
my $querySession = "seriesClient";

my $dir_analyzer = new POE::Component::goanseech::fileWatcher($dirSession);
my $seriesQuery = new POE::Component::goanseech::seriesConnector($querySession);

my $callbacks = 
    {
    "querySession" => $querySession,
    "queryEvent" => "doneParsing",
    };
$dir_analyzer->init($settings,$callbacks);
#share the data lists....
#$seriesQuery->{"dir_list"} = $dir_analyzer->{"dir_list"};
$callbacks = 
{
  "defaultSession" => $dirSession,
  "defaultEvent" => "doneBatch",
};
$seriesQuery->init($settings,$callbacks);

$poe_kernel->run();

__END__


=back

=head1 THANKS

=head1 SEE ALSO

http://poe.perl.org/

=cut

