#!/usr/bin/perl
##############################################################################
=pod

=head1 NAME

extractTorrents 

=head1 DESCRIPTION

extracts the interesting links from a given HTML file and
recusrively parses the files that are pointed inside if they match something
inside the patternServer.


=head1 AUTHOR

  Bruno Bttcher <bboett at adlp dot org>

=head1 COPYRIGHT and LICENCE

 Copyright (c) 2002 Bruno Boettcher

 patternQuery.pl is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; version 2
 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


=cut

##############################################################################
use warnings;
use strict;
sub BEGIN
{
    push (@INC,$ENV{HOME}.'/download/leverloda/goanseech')
        if(!( (join(' ',@INC)) =~ /$ENV{HOME}\/\.leve\/lib/));
}

use Data::Dumper;
use POE::Component::goanseech::URLfetcher;
use POE::Component::goanseech::seriesConnector;
use POE::Component::goanseech::torrentCollector;
use POE::Helper::configLoader;

#sub POE::Kernel::ASSERT_EVENTS () { 1 }
#sub POE::Kernel::ASSERT_STATES () { 1 }
use POE;

my $allowedSettings = { "--config" => "rootpath", "--gui" => "gui" };
my $settings = {
  "rootpath" => $ENV{HOME}."/.goanseech/",
};

my $configurator = new POE::Helper::configLoader($settings);
$configurator->setValidKeys($allowedSettings);

$settings->{"rootpath"} .= "/" if(!($settings->{"rootpath"} =~ /\/$/));

$configurator->load($settings->{"rootpath"}."settings.pm");


my $urlSession = "urlfetcher";
my $querySession = "seriesClient";
my $torrentSum = "torrentClob";

my $url_analyzer = new POE::Component::goanseech::URLfetcher($urlSession);
my $seriesQuery = new POE::Component::goanseech::seriesConnector($querySession);
my $collector = new POE::Component::goanseech::torrentCollector($torrentSum);

my $callbacks = 
    {
    "urlSession" => $urlSession,
    "urlEvent" => "fetchURLs",
    "querySession" => $querySession,
    "queryEvent" => "doneParsing",
    "torrSession" => $torrentSum,
    "torrEvent" => "gotTorrents",
    "urlHandler" => $url_analyzer,
    "defaultSession" => $torrentSum,
    "defaultEvent" => "gotTorrents",
    };
$url_analyzer->init($settings,$callbacks);
$seriesQuery->init($settings, $callbacks);
$collector->init($settings,$callbacks);

print("finished setting up the system, now running poe\n");
$poe_kernel->run();

__END__


=back

=head1 THANKS

=head1 SEE ALSO

http://poe.perl.org/

=cut

